<template>
	<v-form v-model="valid">
		<v-container grid-list-md>
			<v-layout wrap>
				<v-flex xs12>
					<v-container>
						<template v-for="(subtask, index) in value.subtasks">
							<v-layout wrap align-content-center :key="subtask.id">
								<v-flex xs8 align-self-center>
									<v-text-field
										label="Description"
										prepend-icon="fa-sticky-note"
										required
										v-model="subtask.description"
										:rules="descriptionRules"
										@input="update"
									/>
								</v-flex>
								<v-flex xs2 align-self-center>
									<v-checkbox v-model="subtask.done" :rules="doneRules" @input="update" />
								</v-flex>
								<v-flex xs2 align-self-center>
									<v-btn icon @click.stop="removeSubtask(index)">
										<v-icon small>fa-trash</v-icon>
									</v-btn>
								</v-flex>
							</v-layout>
						</template>
					</v-container>
				</v-flex>
				<v-flex xs12>
					<v-btn fab color="primary" @click.stop="addSubtask">
						<!-- style="height: auto" vertically centers the icon on the button -->
						<v-icon style="height: auto">fa-plus</v-icon>
					</v-btn>
				</v-flex>
			</v-layout>
		</v-container>
	</v-form>
</template>

<script>
import { Task } from "@/models/Task";
import { SubTask } from "@/models/SubTask";
import formValidity from "@/mixins/FormValidity";
import taskBasicValidation from "@/mixins/TaskBasicValidation";

const defaults = {
	description: "",
	done: false
};

export default {
	mixins: [formValidity, taskBasicValidation],

	props: {
		value: {
			type: Task,
			required: true
		}
	},

	methods: {
		update() {
			this.$emit("input", this.value);
		},

		addSubtask() {
			this.value.subtasks.push(
				new SubTask(defaults.description, defaults.done)
			);
		},

		removeSubtask(index) {
			this.value.subtasks.splice(index, 1);
		}
	}
};
</script>

